=encoding utf8

=head1 NAME

Mail::Transport::Qmail - transmit messages using external Qmail program

=head1 INHERITANCE

 Mail::Transport::Qmail
   is a Mail::Transport::Send
   is a Mail::Transport
   is a Mail::Reporter

=head1 SYNOPSIS

 my $sender = Mail::Transport::Qmail->new(...);
 $sender->send($message);

=head1 DESCRIPTION

Implements mail transport using the external programs C<'qmail-inject'>,
part of the qmail mail-delivery system.

Extends L<"DESCRIPTION" in Mail::Transport::Send|Mail::Transport::Send/"DESCRIPTION">.
 
=head1 METHODS

Extends L<"METHODS" in Mail::Transport::Send|Mail::Transport::Send/"METHODS">.
 
=head2 Constructors

Extends L<"Constructors" in Mail::Transport::Send|Mail::Transport::Send/"Constructors">.
 
=over 4

=item Mail::Transport::Qmail-E<gt>B<new>(%options)

 -Option    --Defined in     --Default
  executable  Mail::Transport  undef
  hostname    Mail::Transport  'localhost'
  interval    Mail::Transport  30
  log         Mail::Reporter   'WARNINGS'
  password    Mail::Transport  undef
  port        Mail::Transport  undef
  proxy       Mail::Transport  'qmail-inject'
  retry       Mail::Transport  <false>
  timeout     Mail::Transport  120
  trace       Mail::Reporter   'WARNINGS'
  username    Mail::Transport  undef
  via         Mail::Transport  'qmail'

=over 2

=item executable => FILENAME

=item hostname => HOSTNAME|ARRAY

=item interval => SECONDS

=item log => LEVEL

=item password => STRING

=item port => INTEGER

=item proxy => PATH

=item retry => NUMBER|undef

=item timeout => SECONDS

=item trace => LEVEL

=item username => STRING

=item via => CLASS|NAME

=back

=back

=head2 Sending mail

Extends L<"Sending mail" in Mail::Transport::Send|Mail::Transport::Send/"Sending mail">.
 
=over 4

=item $obj-E<gt>B<destinations>( $message, [$address|ARRAY] )

Inherited, see L<Mail::Transport::Send/"Sending mail">

=item $obj-E<gt>B<putContent>($message, $fh, %options)

Inherited, see L<Mail::Transport::Send/"Sending mail">

=item $obj-E<gt>B<send>($message, %options)

Inherited, see L<Mail::Transport::Send/"Sending mail">

=item $obj-E<gt>B<trySend>($message, %options)

=back

=head2 Server connection

Extends L<"Server connection" in Mail::Transport::Send|Mail::Transport::Send/"Server connection">.
 
=over 4

=item $obj-E<gt>B<findBinary>( $name, [@directories] )

Inherited, see L<Mail::Transport/"Server connection">

=item $obj-E<gt>B<remoteHost>()

Inherited, see L<Mail::Transport/"Server connection">

=item $obj-E<gt>B<retry>()

Inherited, see L<Mail::Transport/"Server connection">

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Transport::Send|Mail::Transport::Send/"Error handling">.
 
=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<addReport>($object)

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<defaultTrace>( [$level]|[$loglevel, $tracelevel]|[$level, $callback] )

=item Mail::Transport::Qmail-E<gt>B<defaultTrace>( [$level]|[$loglevel, $tracelevel]|[$level, $callback] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<errors>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<log>( [$level, [$strings]] )

=item Mail::Transport::Qmail-E<gt>B<log>( [$level, [$strings]] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<logPriority>($level)

=item Mail::Transport::Qmail-E<gt>B<logPriority>($level)

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<logSettings>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<report>( [$level] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<reportAll>( [$level] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<trace>( [$level] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<warnings>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Transport::Send|Mail::Transport::Send/"Cleanup">.
 
=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head1 DIAGNOSTICS

=over 4

=item Error: Errors when closing Qmail mailer $program: $!

The Qmail mail transfer agent did start, but was not able to handle the
message for some specific reason.

=item Warning: Message has no destination

It was not possible to figure-out where the message is intended to go
to.

=item Error: Package $package does not implement $method.

Fatal error: the specific package (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.

=item Warning: Resent group does not specify a destination

The message which is sent is the result of a bounce (for instance
created with L<Mail::Message::bounce()|Mail::Message::Construct::Bounce/"Constructing a message">), and therefore starts with a
C<Received> header field.  With the C<bounce>, the new destination(s)
of the message are given, which should be included as C<Resent-To>,
C<Resent-Cc>, and C<Resent-Bcc>.

The C<To>, C<Cc>, and C<Bcc> header information is only used if no
C<Received> was found.  That seems to be the best explanation of the RFC.

As alternative, you may also specify the C<to> option to some of the senders
(for instance L<Mail::Transport::SMTP::send(to)|Mail::Transport::Send/"Sending mail"> to overrule any information
found in the message itself about the destination.

=back

=head1 SEE ALSO

This module is part of Mail-Transport distribution version 3.001,
built on November 08, 2017.

Do not forget to read
L<Mail::Box-Overview>,
L<Mail::Box-Cookbook>, and
L<Mail::Box-Index>.
Examples are included in the Mail-Box distribution, directories 'examples'
and 'scripts'.

Browseable manuals, papers, and other released material van be found
at  Website: F<http://perl.overmeer.net/mailbox/>

The central modules (in separate distributions) in the MailBox suite are:
L<Mail::Message>,
L<Mail::Box>,
L<Mail::Box::IMAP4>,
L<Mail::Box::POP3>,
L<Mail::Box::Parser::C>,
L<Mail::Box::Dbx> (unpublished),
L<Mail::Transport>,
L<Object::Realize::Later>, and
L<User::Identity>.

Please post questions or ideas to the author F<markov@cpan.org>.

=head1 LICENSE

Copyrights 2001-2017 by [Mark Overmeer]. For other contributors see ChangeLog.

This program is free software; you can redistribute it and/or modify it
under the Artistic license.
See F<http://dev.perl.org/licenses/artistic.html>

